Attribute VB_Name = "Module1"
Option Explicit

' Convert the string to Pascal case.
Public Function ToPascalCase(ByVal the_string As String) As String
Dim words() As String
Dim result As String
Dim i As Integer

    ' If there are 0 or 1 characters, just return the string.
    If (Len(the_string) < 2) Then
        ToPascalCase = UCase$(the_string)
        Exit Function
    End If

    ' Split the string into words.
    words = Split(the_string)

    ' Combine the words.
    result = ""
    For i = LBound(words) To UBound(words)
        result = result & _
            UCase$(Mid$(words(i), 1, 1)) & _
            Mid$(words(i), 2)
    Next i

    ToPascalCase = result
End Function

' Convert the string to camel case.
Public Function ToCamelCase(ByVal the_string As String) As String
Dim words() As String
Dim result As String
Dim i As Integer

    ' If there are 0 or 1 characters, just return the string.
    If (Len(the_string) < 2) Then
        ToCamelCase = the_string
        Exit Function
    End If

    ' Split the string into words.
    words = Split(the_string)

    ' Combine the words.
    result = LCase$(words(LBound(words)))
    For i = LBound(words) + 1 To UBound(words)
        result = result & _
            UCase$(Mid$(words(i), 1, 1)) & _
            Mid$(words(i), 2)
    Next i

    ToCamelCase = result
End Function

' Capitalize the first character and add a space before
' each capitalized letter (except the first character).
Public Function ToProperCase(ByVal the_string As String) As String
Dim words() As String
Dim result As String
Dim i As Integer
Dim ch As String

    ' If there are 0 or 1 characters, just return the string.
    If (Len(the_string) < 2) Then
        ToProperCase = UCase$(the_string)
        Exit Function
    End If

    ' Start with the first character.
    result = UCase$(Mid$(the_string, 1, 1))

    ' Add the remaining characters.
    For i = 2 To Len(the_string)
        ch = Mid$(the_string, i, 1)
        If (IsUpper(ch)) Then result = result & " "
        result = result & ch
    Next i

    ToProperCase = result
End Function
' Return True if the string is in all caps.
Private Function IsUpper(ByVal ch As String)
    IsUpper = (UCase$(ch) = ch)
End Function
